#ifndef _linkedlist_h
#define _linkedlist_h

#include <stdio.h>
#include <stdlib.h>

class LinkedList
{
	public:
	LinkedList(void);
	~LinkedList(void);
	int shift(int *data);
	int rshift(int *data);
	int pop(int *data);
	int push(const int data);
	int unshift(const int data);
	int walk(int *data);
	int getsize(void);

	private:
	typedef struct ListElmt_ {
		int data;
		struct ListElmt_ *next;
	} ListElmt;

	typedef struct List_ {
		int size;
		ListElmt *head;
		ListElmt *tail;
	} List;

	List *list;

	ListElmt *walkpos;
	int walk_active;

};

#endif
