/* linked list implementation */
#include "linkedlist.h"

LinkedList::LinkedList(void)
{
	list = new List;
	list->size = 0;
	list->head = NULL;
	list->tail = NULL;
	
	walk_active = 0;
}

LinkedList::~LinkedList(void)
{
	while(list->size > 0)
	{
		this->shift(NULL);
	}
}

/* removes and returns first element on list */
int LinkedList::shift(int *data)
{
	ListElmt *old_element;

	if (list->size == 0)
		return -1;

	if (data) *data = list->head->data;
	old_element = list->head;
	list->head = list->head->next;

	free(old_element);
	list->size--;
	return 0;
}

/* readonly shift; returns first element on list */
int LinkedList::rshift(int *data)
{
	if (list->size == 0)
		return -1;

	if (data) *data = list->head->data;

	return 0;
}

/* removes and returns last element on the list */
int LinkedList::pop(int *data)
{



	list->size--;

	return 0;
}

/* adds a value to the end of the list */
int LinkedList::push(const int data)
{
	ListElmt *new_element;

	new_element = new ListElmt;
	new_element->data = data;
	new_element->next = NULL;

	if (list->head == NULL)
		list->head = new_element;

	if (list->tail == NULL)
		list->tail = new_element;
	else
	{
		list->tail->next = new_element;
		list->tail = new_element;
	}

	list->size++;

	return 0;
}

/* adds a value to the start of the list */
int LinkedList::unshift(const int data)
{
	ListElmt *new_element;

	new_element = new ListElmt;
	new_element->data = data;

	if (list->size == 0)
		list->tail = new_element;

	new_element->next = list->head;
	list->head = new_element;

	list->size++;

	return 0;
}

int LinkedList::getsize()
{
	return list->size;
}

int LinkedList::walk(int *data)
{
	if (!walk_active)
	{
		walk_active = 1;
		walkpos = list->head;
	}

	if (walkpos)
	{
		*data = walkpos->data;
		if (walkpos->next)
		{
			walkpos++;
		}
		else
			walkpos = NULL;
		return 0;
	}
	else
	{
		walk_active = 0;
		return -1;
	}
}
